commit 61aa85e4de91a3b5b28c52a457cd245ab35c155b
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Fri Oct 1 16:31:40 2021 +0200

    Simplify ObjectList: now there's just one object per size.

diff --git a/src/main/java/org/distorted/objectlib/main/ObjectList.java b/src/main/java/org/distorted/objectlib/main/ObjectList.java
index c492d386..09bee804 100644
--- a/src/main/java/org/distorted/objectlib/main/ObjectList.java
+++ b/src/main/java/org/distorted/objectlib/main/ObjectList.java
@@ -19,44 +19,6 @@
 
 package org.distorted.objectlib.main;
 
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-/*
-  CUBE_2 ( 0, new int[] {2 , 12, 12, R.raw.cube2, R.drawable.ui_small_cube2, R.drawable.ui_medium_cube2, R.drawable.ui_big_cube2, R.drawable.ui_huge_cube2} ),
-  CUBE_3 ( 0, new int[] {3 , 16, 17, R.raw.cube3, R.drawable.ui_small_cube3, R.drawable.ui_medium_cube3, R.drawable.ui_big_cube3, R.drawable.ui_huge_cube3} ),
-  CUBE_4 ( 0, new int[] {4 , 20, 24, R.raw.cube4, R.drawable.ui_small_cube4, R.drawable.ui_medium_cube4, R.drawable.ui_big_cube4, R.drawable.ui_huge_cube4} ),
-  CUBE_5 ( 0, new int[] {5 , 24, 28, R.raw.cube5, R.drawable.ui_small_cube5, R.drawable.ui_medium_cube5, R.drawable.ui_big_cube5, R.drawable.ui_huge_cube5} ),
-  JING_2 ( 1, new int[] {2 , 11, 11, R.raw.jing , R.drawable.ui_small_jing2, R.drawable.ui_medium_jing2, R.drawable.ui_big_jing2, R.drawable.ui_huge_jing2} ),
-  PYRA_3 ( 1, new int[] {3 , 10, 10, R.raw.pyra3, R.drawable.ui_small_pyra3, R.drawable.ui_medium_pyra3, R.drawable.ui_big_pyra3, R.drawable.ui_huge_pyra3} ),
-  PYRA_4 ( 1, new int[] {4 , 14, 17, R.raw.pyra4, R.drawable.ui_small_pyra4, R.drawable.ui_medium_pyra4, R.drawable.ui_big_pyra4, R.drawable.ui_huge_pyra4} ),
-  PYRA_5 ( 1, new int[] {5 , 20, 23, R.raw.pyra5, R.drawable.ui_small_pyra5, R.drawable.ui_medium_pyra5, R.drawable.ui_big_pyra5, R.drawable.ui_huge_pyra5} ),
-  KILO_3 ( 2, new int[] {3 , 18, 18, R.raw.kilo3, R.drawable.ui_small_kilo3, R.drawable.ui_medium_kilo3, R.drawable.ui_big_kilo3, R.drawable.ui_huge_kilo3} ),
-  KILO_5 ( 2, new int[] {5 , 33, 33, R.raw.kilo5, R.drawable.ui_small_kilo5, R.drawable.ui_medium_kilo5, R.drawable.ui_big_kilo5, R.drawable.ui_huge_kilo5} ),
-  MEGA_3 ( 2, new int[] {3 , 21, 21, R.raw.mega3, R.drawable.ui_small_mega3, R.drawable.ui_medium_mega3, R.drawable.ui_big_mega3, R.drawable.ui_huge_mega3} ),
-  MEGA_5 ( 2, new int[] {5 , 35, 37, R.raw.mega5, R.drawable.ui_small_mega5, R.drawable.ui_medium_mega5, R.drawable.ui_big_mega5, R.drawable.ui_huge_mega5} ),
-  ULTI_2 ( 3, new int[] {2 , 18, 18, R.raw.ulti , R.drawable.ui_small_ulti , R.drawable.ui_medium_ulti , R.drawable.ui_big_ulti , R.drawable.ui_huge_ulti } ),
-  DIAM_2 ( 3, new int[] {2 , 10, 12, R.raw.diam2, R.drawable.ui_small_diam2, R.drawable.ui_medium_diam2, R.drawable.ui_big_diam2, R.drawable.ui_huge_diam2} ),
-  DIAM_3 ( 3, new int[] {3 , 18, 24, R.raw.diam3, R.drawable.ui_small_diam3, R.drawable.ui_medium_diam3, R.drawable.ui_big_diam3, R.drawable.ui_huge_diam3} ),
-  DIAM_4 ( 3, new int[] {4 , 32, 32, R.raw.diam4, R.drawable.ui_small_diam4, R.drawable.ui_medium_diam4, R.drawable.ui_big_diam4, R.drawable.ui_huge_diam4} ),
-  DINO_3 ( 4, new int[] {3 , 10, 10, R.raw.dino , R.drawable.ui_small_dino , R.drawable.ui_medium_dino , R.drawable.ui_big_dino , R.drawable.ui_huge_dino } ),
-  DIN4_3 ( 4, new int[] {3 ,  7,  7, R.raw.dino , R.drawable.ui_small_din4 , R.drawable.ui_medium_din4 , R.drawable.ui_big_din4 , R.drawable.ui_huge_din4 } ),
-  REDI_3 ( 4, new int[] {3 , 14, 16, R.raw.redi , R.drawable.ui_small_redi , R.drawable.ui_medium_redi , R.drawable.ui_big_redi , R.drawable.ui_huge_redi } ),
-  HELI_3 ( 4, new int[] {3 , 18, 20, R.raw.heli , R.drawable.ui_small_heli , R.drawable.ui_medium_heli , R.drawable.ui_big_heli , R.drawable.ui_huge_heli } ),
-  SKEW_2 ( 5, new int[] {2 , 11, 11, R.raw.skew2, R.drawable.ui_small_skew2, R.drawable.ui_medium_skew2, R.drawable.ui_big_skew2, R.drawable.ui_huge_skew2} ),
-  SKEW_3 ( 5, new int[] {3 , 17, 21, R.raw.skew3, R.drawable.ui_small_skew3, R.drawable.ui_medium_skew3, R.drawable.ui_big_skew3, R.drawable.ui_huge_skew3} ),
-  IVY_2  ( 5, new int[] {2 ,  8,  8, R.raw.ivy  , R.drawable.ui_small_ivy  , R.drawable.ui_medium_ivy  , R.drawable.ui_big_ivy  , R.drawable.ui_huge_ivy  } ),
-  REX_3  ( 5, new int[] {3 , 16, 19, R.raw.rex  , R.drawable.ui_small_rex  , R.drawable.ui_medium_rex  , R.drawable.ui_big_rex  , R.drawable.ui_huge_rex  } ),
-  BAN1_3 ( 6, new int[] {3 , 16, 16, R.raw.ban1 , R.drawable.ui_small_ban1 , R.drawable.ui_medium_ban1 , R.drawable.ui_big_ban1 , R.drawable.ui_huge_ban1 } ),
-  BAN2_3 ( 6, new int[] {3 , 16, 16, R.raw.ban2 , R.drawable.ui_small_ban2 , R.drawable.ui_medium_ban2 , R.drawable.ui_big_ban2 , R.drawable.ui_huge_ban2 } ),
-  BAN3_3 ( 6, new int[] {3 , 16, 16, R.raw.ban3 , R.drawable.ui_small_ban3 , R.drawable.ui_medium_ban3 , R.drawable.ui_big_ban3 , R.drawable.ui_huge_ban3 } ),
-  BAN4_3 ( 6, new int[] {3 , 16, 16, R.raw.ban4 , R.drawable.ui_small_ban4 , R.drawable.ui_medium_ban4 , R.drawable.ui_big_ban4 , R.drawable.ui_huge_ban4 } ),
-  SQU1_3 ( 7, new int[] {3 , 24, 24, R.raw.squa1, R.drawable.ui_small_squa1, R.drawable.ui_medium_squa1, R.drawable.ui_big_squa1, R.drawable.ui_huge_squa1} ),
-  SQU2_3 ( 7, new int[] {3 , 24, 24, R.raw.squa2, R.drawable.ui_small_squa2, R.drawable.ui_medium_squa2, R.drawable.ui_big_squa2, R.drawable.ui_huge_squa2} ),
-  MIRR_2 ( 7, new int[] {2 , 12, 12, R.raw.mirr2, R.drawable.ui_small_mirr2, R.drawable.ui_medium_mirr2, R.drawable.ui_big_mirr2, R.drawable.ui_huge_mirr2} ),
-  MIRR_3 ( 7, new int[] {3 , 16, 17, R.raw.mirr3, R.drawable.ui_small_mirr3, R.drawable.ui_medium_mirr3, R.drawable.ui_big_mirr3, R.drawable.ui_huge_mirr3} ),
-  ;
-*/
-
 import android.content.res.Resources;
 
 import org.distorted.library.main.DistortedEffects;
@@ -86,210 +48,73 @@ import org.distorted.objectlib.objects.TwistySquare1;
 import org.distorted.objectlib.objects.TwistySquare2;
 import org.distorted.objectlib.objects.TwistyUltimate;
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
 public enum ObjectList
   {
-  ///////////////////// Size // DB Level // NumScrambles // Mesh // small icon // medium icon // big icon // huge icon
-
-  CUBE (
-         new int[][] {
-                       {2 , 12, 12, R.drawable.ui_small_cube2, R.drawable.ui_medium_cube2, R.drawable.ui_big_cube2, R.drawable.ui_huge_cube2} ,
-                       {3 , 16, 17, R.drawable.ui_small_cube3, R.drawable.ui_medium_cube3, R.drawable.ui_big_cube3, R.drawable.ui_huge_cube3} ,
-                       {4 , 20, 24, R.drawable.ui_small_cube4, R.drawable.ui_medium_cube4, R.drawable.ui_big_cube4, R.drawable.ui_huge_cube4} ,
-                       {5 , 24, 28, R.drawable.ui_small_cube5, R.drawable.ui_medium_cube5, R.drawable.ui_big_cube5, R.drawable.ui_huge_cube5}
-                     },
-         0
-       ),
-
-  JING (
-         new int[][] {
-                       {2 , 11, 11, R.drawable.ui_small_jing2, R.drawable.ui_medium_jing2, R.drawable.ui_big_jing2, R.drawable.ui_huge_jing2} ,
-                     },
-         1
-       ),
-
-  PYRA (
-         new int[][] {
-                       {3 , 10, 10, R.drawable.ui_small_pyra3, R.drawable.ui_medium_pyra3, R.drawable.ui_big_pyra3, R.drawable.ui_huge_pyra3} ,
-                       {4 , 15, 17, R.drawable.ui_small_pyra4, R.drawable.ui_medium_pyra4, R.drawable.ui_big_pyra4, R.drawable.ui_huge_pyra4} ,
-                       {5 , 20, 23, R.drawable.ui_small_pyra5, R.drawable.ui_medium_pyra5, R.drawable.ui_big_pyra5, R.drawable.ui_huge_pyra5}
-                     },
-         1
-       ),
-
-  KILO (
-         new int[][] {
-                       {3 , 18, 18, R.drawable.ui_small_kilo3, R.drawable.ui_medium_kilo3, R.drawable.ui_big_kilo3, R.drawable.ui_huge_kilo3} ,
-                       {5 , 33, 33, R.drawable.ui_small_kilo5, R.drawable.ui_medium_kilo5, R.drawable.ui_big_kilo5, R.drawable.ui_huge_kilo5} ,
-                     },
-         2
-       ),
-
-  MEGA (
-         new int[][] {
-                       {3 , 21, 21, R.drawable.ui_small_mega3, R.drawable.ui_medium_mega3, R.drawable.ui_big_mega3, R.drawable.ui_huge_mega3} ,
-                       {5 , 35, 37, R.drawable.ui_small_mega5, R.drawable.ui_medium_mega5, R.drawable.ui_big_mega5, R.drawable.ui_huge_mega5} ,
-                     },
-         2
-       ),
-
-  ULTI (
-         new int[][] {
-                       {2 , 18, 18, R.drawable.ui_small_ulti, R.drawable.ui_medium_ulti, R.drawable.ui_big_ulti, R.drawable.ui_huge_ulti} ,
-                     },
-         3
-       ),
-
-  DIAM (
-         new int[][] {
-                       {2 , 10, 12, R.drawable.ui_small_diam2, R.drawable.ui_medium_diam2, R.drawable.ui_big_diam2, R.drawable.ui_huge_diam2} ,
-                       {3 , 18, 24, R.drawable.ui_small_diam3, R.drawable.ui_medium_diam3, R.drawable.ui_big_diam3, R.drawable.ui_huge_diam3} ,
-                       {4 , 32, 32, R.drawable.ui_small_diam4, R.drawable.ui_medium_diam4, R.drawable.ui_big_diam4, R.drawable.ui_huge_diam4} ,
-                     },
-         3
-       ),
-
-  DINO (
-         new int[][] {
-                       {3 , 10, 10, R.drawable.ui_small_dino, R.drawable.ui_medium_dino, R.drawable.ui_big_dino, R.drawable.ui_huge_dino} ,
-                     },
-         4
-       ),
-
-  DIN4 (
-         new int[][] {
-                       {3 , 7, 7, R.drawable.ui_small_din4, R.drawable.ui_medium_din4, R.drawable.ui_big_din4, R.drawable.ui_huge_din4} ,
-                     },
-         4
-       ),
-
-  REDI (
-         new int[][] {
-                       {3 , 14, 16, R.drawable.ui_small_redi, R.drawable.ui_medium_redi, R.drawable.ui_big_redi, R.drawable.ui_huge_redi} ,
-                     },
-         4
-       ),
-
-  HELI (
-         new int[][] {
-                       {3 , 18, 20, R.drawable.ui_small_heli, R.drawable.ui_medium_heli, R.drawable.ui_big_heli, R.drawable.ui_huge_heli} ,
-                     },
-         4
-       ),
-
-  SKEW (
-         new int[][] {
-                       {2 , 11, 11, R.drawable.ui_small_skew2, R.drawable.ui_medium_skew2, R.drawable.ui_big_skew2, R.drawable.ui_huge_skew2} ,
-                       {3 , 17, 21, R.drawable.ui_small_skew3, R.drawable.ui_medium_skew3, R.drawable.ui_big_skew3, R.drawable.ui_huge_skew3} ,
-                     },
-         5
-       ),
-
-  IVY  (
-         new int[][] {
-                       {2 , 8, 8, R.drawable.ui_small_ivy, R.drawable.ui_medium_ivy, R.drawable.ui_big_ivy, R.drawable.ui_huge_ivy} ,
-                     },
-         5
-       ),
-
-  REX  (
-         new int[][] {
-                       {3 , 16, 19, R.drawable.ui_small_rex, R.drawable.ui_medium_rex, R.drawable.ui_big_rex, R.drawable.ui_huge_rex} ,
-                     },
-         5
-       ),
-
-  BAN1 (
-         new int[][] {
-                       {3 , 16, 16, R.drawable.ui_small_ban1, R.drawable.ui_medium_ban1, R.drawable.ui_big_ban1, R.drawable.ui_huge_ban1} ,
-                     },
-         6
-       ),
-
-  BAN2 (
-         new int[][] {
-                       {3 , 16, 16, R.drawable.ui_small_ban2, R.drawable.ui_medium_ban2, R.drawable.ui_big_ban2, R.drawable.ui_huge_ban2} ,
-                     },
-         6
-       ),
-
-  BAN3 (
-         new int[][] {
-                       {3 , 16, 16, R.drawable.ui_small_ban3, R.drawable.ui_medium_ban3, R.drawable.ui_big_ban3, R.drawable.ui_huge_ban3} ,
-                     },
-         6
-       ),
-
-  BAN4 (
-         new int[][] {
-                       {3 , 16, 16, R.drawable.ui_small_ban4, R.drawable.ui_medium_ban4, R.drawable.ui_big_ban4, R.drawable.ui_huge_ban4} ,
-                     },
-         6
-       ),
-
-  SQU1 (
-         new int[][] {
-                       {3 , 24, 24, R.drawable.ui_small_squa1, R.drawable.ui_medium_squa1, R.drawable.ui_big_squa1, R.drawable.ui_huge_squa1} ,
-                     },
-         7
-       ),
-
-  SQU2 (
-         new int[][] {
-                       {3 , 24, 24, R.drawable.ui_small_squa2, R.drawable.ui_medium_squa2, R.drawable.ui_big_squa2, R.drawable.ui_huge_squa2} ,
-                     },
-         7
-       ),
-
-  MIRR (
-         new int[][] {
-                       {2 , 12, 12, R.drawable.ui_small_mirr2, R.drawable.ui_medium_mirr2, R.drawable.ui_big_mirr2, R.drawable.ui_huge_mirr2} ,
-                       {3 , 16, 17, R.drawable.ui_small_mirr3, R.drawable.ui_medium_mirr3, R.drawable.ui_big_mirr3, R.drawable.ui_huge_mirr3} ,
-                     },
-         7
-       ),
+  CUBE_2 ( 0, 2, 12, 12, R.drawable.small_cube2, R.drawable.medium_cube2, R.drawable.big_cube2, R.drawable.huge_cube2),
+  CUBE_3 ( 0, 3, 16, 17, R.drawable.small_cube3, R.drawable.medium_cube3, R.drawable.big_cube3, R.drawable.huge_cube3),
+  CUBE_4 ( 0, 4, 20, 24, R.drawable.small_cube4, R.drawable.medium_cube4, R.drawable.big_cube4, R.drawable.huge_cube4),
+  CUBE_5 ( 0, 5, 24, 28, R.drawable.small_cube5, R.drawable.medium_cube5, R.drawable.big_cube5, R.drawable.huge_cube5),
+  JING_2 ( 1, 2, 11, 11, R.drawable.small_jing2, R.drawable.medium_jing2, R.drawable.big_jing2, R.drawable.huge_jing2),
+  PYRA_3 ( 1, 3, 10, 10, R.drawable.small_pyra3, R.drawable.medium_pyra3, R.drawable.big_pyra3, R.drawable.huge_pyra3),
+  PYRA_4 ( 1, 4, 14, 17, R.drawable.small_pyra4, R.drawable.medium_pyra4, R.drawable.big_pyra4, R.drawable.huge_pyra4),
+  PYRA_5 ( 1, 5, 20, 23, R.drawable.small_pyra5, R.drawable.medium_pyra5, R.drawable.big_pyra5, R.drawable.huge_pyra5),
+  KILO_3 ( 2, 3, 18, 18, R.drawable.small_kilo3, R.drawable.medium_kilo3, R.drawable.big_kilo3, R.drawable.huge_kilo3),
+  KILO_5 ( 2, 5, 33, 33, R.drawable.small_kilo5, R.drawable.medium_kilo5, R.drawable.big_kilo5, R.drawable.huge_kilo5),
+  MEGA_3 ( 2, 3, 21, 21, R.drawable.small_mega3, R.drawable.medium_mega3, R.drawable.big_mega3, R.drawable.huge_mega3),
+  MEGA_5 ( 2, 5, 35, 37, R.drawable.small_mega5, R.drawable.medium_mega5, R.drawable.big_mega5, R.drawable.huge_mega5),
+  ULTI_2 ( 3, 2, 18, 18, R.drawable.small_ulti , R.drawable.medium_ulti , R.drawable.big_ulti , R.drawable.huge_ulti ),
+  DIAM_2 ( 3, 2, 10, 12, R.drawable.small_diam2, R.drawable.medium_diam2, R.drawable.big_diam2, R.drawable.huge_diam2),
+  DIAM_3 ( 3, 3, 18, 24, R.drawable.small_diam3, R.drawable.medium_diam3, R.drawable.big_diam3, R.drawable.huge_diam3),
+  DIAM_4 ( 3, 4, 32, 32, R.drawable.small_diam4, R.drawable.medium_diam4, R.drawable.big_diam4, R.drawable.huge_diam4),
+  DINO_3 ( 4, 3, 10, 10, R.drawable.small_dino , R.drawable.medium_dino , R.drawable.big_dino , R.drawable.huge_dino ),
+  DIN4_3 ( 4, 3,  7,  7, R.drawable.small_din4 , R.drawable.medium_din4 , R.drawable.big_din4 , R.drawable.huge_din4 ),
+  REDI_3 ( 4, 3, 14, 16, R.drawable.small_redi , R.drawable.medium_redi , R.drawable.big_redi , R.drawable.huge_redi ),
+  HELI_3 ( 4, 3, 18, 20, R.drawable.small_heli , R.drawable.medium_heli , R.drawable.big_heli , R.drawable.huge_heli ),
+  SKEW_2 ( 5, 2, 11, 11, R.drawable.small_skew2, R.drawable.medium_skew2, R.drawable.big_skew2, R.drawable.huge_skew2),
+  SKEW_3 ( 5, 3, 17, 21, R.drawable.small_skew3, R.drawable.medium_skew3, R.drawable.big_skew3, R.drawable.huge_skew3),
+  IVY_2  ( 5, 2,  8,  8, R.drawable.small_ivy  , R.drawable.medium_ivy  , R.drawable.big_ivy  , R.drawable.huge_ivy  ),
+  REX_3  ( 5, 3, 16, 19, R.drawable.small_rex  , R.drawable.medium_rex  , R.drawable.big_rex  , R.drawable.huge_rex  ),
+  BAN1_3 ( 6, 3, 16, 16, R.drawable.small_ban1 , R.drawable.medium_ban1 , R.drawable.big_ban1 , R.drawable.huge_ban1 ),
+  BAN2_3 ( 6, 3, 16, 16, R.drawable.small_ban2 , R.drawable.medium_ban2 , R.drawable.big_ban2 , R.drawable.huge_ban2 ),
+  BAN3_3 ( 6, 3, 16, 16, R.drawable.small_ban3 , R.drawable.medium_ban3 , R.drawable.big_ban3 , R.drawable.huge_ban3 ),
+  BAN4_3 ( 6, 3, 16, 16, R.drawable.small_ban4 , R.drawable.medium_ban4 , R.drawable.big_ban4 , R.drawable.huge_ban4 ),
+  SQU1_3 ( 7, 3, 24, 24, R.drawable.small_squa1, R.drawable.medium_squa1, R.drawable.big_squa1, R.drawable.huge_squa1),
+  SQU2_3 ( 7, 3, 24, 24, R.drawable.small_squa2, R.drawable.medium_squa2, R.drawable.big_squa2, R.drawable.huge_squa2),
+  MIRR_2 ( 7, 2, 12, 12, R.drawable.small_mirr2, R.drawable.medium_mirr2, R.drawable.big_mirr2, R.drawable.huge_mirr2),
+  MIRR_3 ( 7, 3, 16, 17, R.drawable.small_mirr3, R.drawable.medium_mirr3, R.drawable.big_mirr3, R.drawable.huge_mirr3),
   ;
 
   public static final int NUM_OBJECTS = values().length;
-  public static final int MAX_NUM_OBJECTS;
   public static final int MAX_LEVEL;
   public static final int MAX_SCRAMBLE;
   public static final int MAX_OBJECT_SIZE;
 
-  private final int[] mObjectSizes, mDBLevels, mNumScrambles, mSmallIconIDs, mMediumIconIDs, mBigIconIDs, mHugeIconIDs;
-  private final int mRow, mNumSizes;
+  private final int mRow, mSize, mDBLevels, mNumScrambles;
+  private final int mSmallIconID, mMediumIconID, mBigIconID, mHugeIconID;
 
   private static final ObjectList[] objects;
-  private static int mNumAll;
   private static int[] mIndices;
   private static int mColCount, mRowCount;
 
   static
     {
-    mNumAll = 0;
-    int num, i = 0;
+    int i = 0;
     objects = new ObjectList[NUM_OBJECTS];
-    int maxNum     = Integer.MIN_VALUE;
     int maxLevel   = Integer.MIN_VALUE;
     int maxScramble= Integer.MIN_VALUE;
     int maxSize    = Integer.MIN_VALUE;
 
     for(ObjectList object: ObjectList.values())
       {
-      objects[i] = object;
-      i++;
-      num = object.mObjectSizes.length;
-      mNumAll += num;
-      if( num> maxNum ) maxNum = num;
-
-      for(int j=0; j<num; j++)
-        {
-        if( object.mNumScrambles[j]> maxScramble ) maxScramble= object.mNumScrambles[j];
-        if( object.mDBLevels[j]    > maxLevel    ) maxLevel   = object.mDBLevels[j];
-        if( object.mObjectSizes[j] > maxSize     ) maxSize    = object.mObjectSizes[j];
-        }
+      objects[i++] = object;
+
+      if( object.mNumScrambles> maxScramble ) maxScramble= object.mNumScrambles;
+      if( object.mDBLevels    > maxLevel    ) maxLevel   = object.mDBLevels;
+      if( object.mSize        > maxSize     ) maxSize    = object.mSize;
       }
 
-    MAX_NUM_OBJECTS = maxNum;
     MAX_LEVEL       = maxLevel;
     MAX_SCRAMBLE    = maxScramble;
     MAX_OBJECT_SIZE = maxSize;
@@ -325,10 +150,7 @@ public enum ObjectList
 
     for(int object=0; object<NUM_OBJECTS; object++)
       {
-      if( objects[object].mRow == row )
-        {
-        num += objects[object].mNumSizes;
-        }
+      if( objects[object].mRow == row ) num++;
       }
 
     return num;
@@ -365,71 +187,16 @@ public enum ObjectList
 
   public static ObjectList getObject(int ordinal)
     {
-    return ordinal>=0 && ordinal<NUM_OBJECTS ? objects[ordinal] : CUBE;
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public static int pack(int object, int sizeIndex)
-    {
-    int ret = 0;
-    for(int i=0; i<object; i++) ret += objects[i].mObjectSizes.length;
-
-    return ret+sizeIndex;
+    return ordinal>=0 && ordinal<NUM_OBJECTS ? objects[ordinal] : CUBE_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public static int unpackSizeIndex(int number)
-    {
-    int num;
-
-    for(int i=0; i<NUM_OBJECTS; i++)
-      {
-      num = objects[i].mObjectSizes.length;
-      if( number<num ) return number;
-      number -= num;
-      }
-
-    return -1;
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public static int unpackObject(int number)
+  public static int getOrdinal(String name)
     {
-    int num;
-
     for(int i=0; i<NUM_OBJECTS; i++)
       {
-      num = objects[i].mObjectSizes.length;
-      if( number<num ) return i;
-      number -= num;
-      }
-
-    return -1;
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public static int unpackObjectFromString(String obj)
-    {
-    int u = obj.indexOf('_');
-    int l = obj.length();
-
-    if( u>0 )
-      {
-      String name = obj.substring(0,u);
-      int size = Integer.parseInt( obj.substring(u+1,l) );
-
-      for(int i=0; i<NUM_OBJECTS; i++)
-        {
-        if( objects[i].name().equals(name) )
-          {
-          int sizeIndex = getSizeIndex(i,size);
-          return pack(i,sizeIndex);
-          }
-        }
+      if( objects[i].name().equals(name) ) return i;
       }
 
     return -1;
@@ -439,24 +206,12 @@ public enum ObjectList
 
   public static String getObjectList()
     {
-    String name;
     StringBuilder list = new StringBuilder();
-    int len;
-    int[] sizes;
 
     for(int i=0; i<NUM_OBJECTS; i++)
       {
-      sizes = objects[i].mObjectSizes;
-      len   = sizes.length;
-      name  = objects[i].name();
-
-      for(int j=0; j<len; j++)
-        {
-        if( i>0 || j>0 ) list.append(',');
-        list.append(name);
-        list.append('_');
-        list.append(sizes[j]);
-        }
+      if( i>0 ) list.append(',');
+      list.append(objects[i].name());
       }
 
     return list.toString();
@@ -464,120 +219,50 @@ public enum ObjectList
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public static int getTotal()
-    {
-    return mNumAll;
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public static int getDBLevel(int ordinal, int sizeIndex)
-    {
-    if( ordinal>=0 && ordinal<NUM_OBJECTS )
-      {
-      int num = objects[ordinal].mObjectSizes.length;
-      return sizeIndex>=0 && sizeIndex<num ? objects[ordinal].mDBLevels[sizeIndex] : 0;
-      }
-
-    return 0;
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public static int getNumScramble(int ordinal, int sizeIndex)
+  public static int getDBLevel(int ordinal)
     {
-    if( ordinal>=0 && ordinal<NUM_OBJECTS )
-      {
-      int num = objects[ordinal].mObjectSizes.length;
-      return sizeIndex>=0 && sizeIndex<num ? objects[ordinal].mNumScrambles[sizeIndex] : 0;
-      }
-
-    return 0;
+    return ordinal>=0 && ordinal<NUM_OBJECTS ? objects[ordinal].mDBLevels : 0;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public static int getOrdinal(String name)
+  public static int getNumScramble(int ordinal)
     {
-    for(int i=0; i<NUM_OBJECTS; i++)
-      {
-      if(objects[i].name().equals(name)) return i;
-      }
-
-    return -1;
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public static int getSizeIndex(int ordinal, int size)
-    {
-    if( ordinal>=0 && ordinal<NUM_OBJECTS )
-      {
-      int[] sizes = objects[ordinal].getSizes();
-      int len = sizes.length;
-
-      for(int i=0; i<len; i++)
-        {
-        if( sizes[i]==size ) return i;
-        }
-      }
-
-    return -1;
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  ObjectList(int[][] info, int row)
-    {
-    mNumSizes = info.length;
-
-    mObjectSizes  = new int[mNumSizes];
-    mDBLevels     = new int[mNumSizes];
-    mNumScrambles = new int[mNumSizes];
-    mSmallIconIDs = new int[mNumSizes];
-    mMediumIconIDs= new int[mNumSizes];
-    mBigIconIDs   = new int[mNumSizes];
-    mHugeIconIDs  = new int[mNumSizes];
-
-    for(int i=0; i<mNumSizes; i++)
-      {
-      mObjectSizes[i]  = info[i][0];
-      mDBLevels[i]     = info[i][1];
-      mNumScrambles[i] = info[i][2];
-      mSmallIconIDs[i] = info[i][3];
-      mMediumIconIDs[i]= info[i][4];
-      mBigIconIDs[i]   = info[i][5];
-      mHugeIconIDs[i]  = info[i][6];
-      }
-
-    mRow  = row;
+    return ordinal>=0 && ordinal<NUM_OBJECTS ? objects[ordinal].mNumScrambles : 0;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public int[] getSizes()
+  ObjectList(int row, int size, int db, int scrambles, int smallIcon, int mediumIcon, int bigIcon, int hugeIcon)
     {
-    return mObjectSizes;
+    mRow         = row;
+    mSize        = size;
+    mDBLevels    = db;
+    mNumScrambles= scrambles;
+    mSmallIconID = smallIcon;
+    mMediumIconID= mediumIcon;
+    mBigIconID   = bigIcon;
+    mHugeIconID  = hugeIcon;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public int[] getIconIDs(int size)
+  public int getIconID(int size)
     {
     switch(size)
       {
-      case 0: return mSmallIconIDs;
-      case 1: return mMediumIconIDs;
-      case 2: return mBigIconIDs;
-      case 3: return mHugeIconIDs;
+      case 0: return mSmallIconID;
+      case 1: return mMediumIconID;
+      case 2: return mBigIconID;
+      case 3: return mHugeIconID;
       }
 
-    return mSmallIconIDs;
+    return mSmallIconID;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public TwistyObject create(int size, Static4D quat, int[][] moves, Resources res, int scrWidth)
+  public TwistyObject create(Static4D quat, int[][] moves, Resources res, int scrWidth)
     {
     DistortedTexture texture = new DistortedTexture();
     DistortedEffects effects = new DistortedEffects();
@@ -585,27 +270,38 @@ public enum ObjectList
 
     switch(ordinal())
       {
-      case  0: return new TwistyCube          (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case  1: return new TwistyJing          (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case  2: return new TwistyPyraminx      (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case  3: return new TwistyKilominx      (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case  4: return new TwistyMegaminx      (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case  5: return new TwistyUltimate      (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case  6: return new TwistyDiamond       (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case  7: return new TwistyDino6         (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case  8: return new TwistyDino4         (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case  9: return new TwistyRedi          (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 10: return new TwistyHelicopter    (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 11: return new TwistySkewb         (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 12: return new TwistyIvy           (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 13: return new TwistyRex           (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 14: return new TwistyBandagedFused (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 15: return new TwistyBandaged2Bar  (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 16: return new TwistyBandaged3Plate(size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 17: return new TwistyBandagedEvil  (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 18: return new TwistySquare1       (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 19: return new TwistySquare2       (size, quat, texture, mesh, effects, moves, res, scrWidth);
-      case 20: return new TwistyMirror        (size, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  0: return new TwistyCube          (objects[ 0].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  1: return new TwistyCube          (objects[ 1].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  2: return new TwistyCube          (objects[ 2].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  3: return new TwistyCube          (objects[ 3].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  4: return new TwistyJing          (objects[ 4].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  5: return new TwistyPyraminx      (objects[ 5].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  6: return new TwistyPyraminx      (objects[ 6].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  7: return new TwistyPyraminx      (objects[ 7].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  8: return new TwistyKilominx      (objects[ 8].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case  9: return new TwistyKilominx      (objects[ 9].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 10: return new TwistyMegaminx      (objects[10].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 11: return new TwistyMegaminx      (objects[11].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 12: return new TwistyUltimate      (objects[12].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 13: return new TwistyDiamond       (objects[13].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 14: return new TwistyDiamond       (objects[14].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 15: return new TwistyDiamond       (objects[15].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 16: return new TwistyDino6         (objects[16].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 17: return new TwistyDino4         (objects[17].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 18: return new TwistyRedi          (objects[18].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 19: return new TwistyHelicopter    (objects[19].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 20: return new TwistySkewb         (objects[20].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 21: return new TwistySkewb         (objects[21].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 22: return new TwistyIvy           (objects[22].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 23: return new TwistyRex           (objects[23].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 24: return new TwistyBandagedFused (objects[24].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 25: return new TwistyBandaged2Bar  (objects[25].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 26: return new TwistyBandaged3Plate(objects[26].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 27: return new TwistyBandagedEvil  (objects[27].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 28: return new TwistySquare1       (objects[28].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 29: return new TwistySquare2       (objects[29].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 30: return new TwistyMirror        (objects[30].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
+      case 31: return new TwistyMirror        (objects[31].mSize, quat, texture, mesh, effects, moves, res, scrWidth);
       }
 
     return null;
